function [data, uresid] = return_dgp_blk(theta,other,phi,Z,Zblock,eps_dist,seed,rng_type,blks)

T = other(1);
N = other(2);

size_phi = size(phi);
if size_phi(1) == 1
    phi = repmat(phi,N,1);
end

[uresid,~] = dgp_blk(theta,other,Z,Zblock,eps_dist,seed,rng_type,blks);

resid=NaN(T,N); 
garchdata=NaN(T,N);
data=NaN(T,N);

for dd = 1:N
    resid(:,dd) = norminv(uresid(:,dd),0,1); % innovation assumed to be NORMAL
    garchdata(:,dd)=tarch_simulate(resid(:,dd),[phi(dd,3),phi(dd,4),phi(dd,5)]',1,0,1,'NORMAL',2); % P=1,O=0,Q=1 leads to GARCH model
    data(:,dd)=armaxfilter_simulate(garchdata(:,dd),phi(dd,1),1,phi(dd,2));
end

