function y = var_est_blk(resData,simdata,q,B,seed,blks,exog,rhoS)


[T,N]=size(resData);
sizesim = size(simdata);
M = max(blks);
m = M*(length(q)+rhoS);
S = sizesim(1)/T;
b=B/T;


if exog == 1
    rng(seed+3, 'twister')
    myrand = randi([1 T],[B 1]);
    EtaB   = zeros(B,N);
    EtasimB =zeros(B*S,N);
    for ii=1:B
        ll = myrand(ii,1);
        EtaB(ii,:)= resData(ll,:);
        EtasimB((ii-1)*S+1:(ii-1)*S+S,:) = simdata([ll:T:(S-1)*T+ll],:);% simdata((ll-1)*S+1:(ll-1)*S+S,:);
    end
    clear myrand

    % Compute moments of all bootstrap samples
    mtb = zeros(m,b);
    mtbs= zeros(m,b);
    for jj=0:(b-1)
        rank_EtaB =     tiedrank(EtaB((1+T*jj):(T+T*jj),:))/(T+1);
        mtb(:,jj+1)=    momfunc_Equidep_blk(rank_EtaB,q,blks,rhoS);
        clear rank_EtaB
        rank_EtasimB =  tiedrank(EtasimB((1+T*S*jj):(S*T+S*T*jj),:))/(T*S+1);
        mtbs(:,jj+1)=   momfunc_Equidep_blk(rank_EtasimB,q,blks,rhoS);
        clear rank_EtasimB
    end
    clear EtaB  EtasimB


    rankData = tiedrank(resData)/(T+1);
    mts      =  momfunc_Equidep_blk(rankData,q,blks,rhoS); mts = repmat(mts,1,b);
    clear rankData resData
    rankDataS = tiedrank(simdata)/(S*T+1);
    mtS       = momfunc_Equidep_blk(rankDataS,q,blks,rhoS); mtS = repmat(mtS,1,b);
    clear rankDataS simdata
    y  = (T/b)*((mtb-mtbs-mts+mtS)*(mtb-mtbs-mts+mtS)');

else
    rng(seed+3, 'twister')
    myrand = randi([1 T],[B 1]);
    EtaB = zeros(B,N);
    for ii=1:B
        EtaB(ii,:)= resData(myrand(ii,1),:);
    end
    clear myrand
    mtb = zeros(m,b);
    for jj=0:(b-1)
    	rank_EtaB = tiedrank(EtaB((1+T*jj):(T+T*jj),:))/(T+1);
        mtb(:,jj+1)= momfunc_Equidep_blk(rank_EtaB,q,blks,rhoS);
    	clear rank_EtaB
    end
    clear EtaB

    rankData = tiedrank(resData)/(T+1);
    mts = momfunc_Equidep_blk(rankData,q,blks,rhoS); mts = repmat(mts,1,b);
    clear rankData resData

    y = (T/b)*((mtb-mts)*(mtb-mts)');
end
end
