function [u,raw_u] = dgp(theta, other, reg, model, seed, rng_type, blks)

T = other(1);
N = other(2);

reg_type = model(1); F_type = model(2); eps_type = model(3);

nu    = 1/theta(1);
lam   = theta(2);
gamma = theta(3:end);


M       = max(blks);
blSize  = nan(M,1);
eps     = zeros(T,N);
for i = 1:M
    blSize(i) = sum(blks == i);
end

if strcmp(reg_type, 'three')
    Z1 = reg(:,1); Z2 = reg(:,2); Z3 = reg(:,3);
else
    Z1 = reg;
end

kk = 2*strcmp(reg_type, 'three');
if strcmp(F_type, 'three')
    F1   = skewtdis_inv2(rand(RandStream.create(rng_type,'NumStreams',N+kk+4,'StreamIndices',kk+2,'Seed',seed),T,1),nu,lam);
    F2   = skewtdis_inv2(rand(RandStream.create(rng_type,'NumStreams',N+kk+4,'StreamIndices',kk+3,'Seed',seed),T,1),nu,lam);
    F3   = skewtdis_inv2(rand(RandStream.create(rng_type,'NumStreams',N+kk+4,'StreamIndices',kk+4,'Seed',seed),T,1),nu,lam);
    if strcmp(eps_type, 'norm')
        for i = 1:N
            eps(:,i) = randn(RandStream.create(rng_type,'NumStreams',N+kk+4,'StreamIndices',i+kk+4,'Seed',seed),T,1);%
        end
    elseif strcmp(eps_type, 'st')
        for i = 1:N
            eps(:,i) = skewtdis_inv2(rand(RandStream.create(rng_type,'NumStreams',N+kk+4,'StreamIndices',i+kk+4,'Seed',seed),T,1),nu,0);
        end
    end
elseif strcmp(F_type, 'one')
    F    = skewtdis_inv2(rand(RandStream.create(rng_type,'NumStreams',N+kk+2,'StreamIndices',kk+2,'Seed',seed),T,1),nu,lam);
    if strcmp(eps_type, 'norm')
        for i = 1:N
            eps(:,i) = randn(RandStream.create(rng_type,'NumStreams',N+kk+2,'StreamIndices',i+kk+2,'Seed',seed),T,1);%
        end
    elseif strcmp(eps_type, 'st')
        for i = 1:N
            eps(:,i) = skewtdis_inv2(rand(RandStream.create(rng_type,'NumStreams',N+kk+2,'StreamIndices',i+kk+2,'Seed',seed),T,1),nu,0);
        end
    end
end


if strcmp(reg_type, 'three')
    raw_u =   [(Z1*ones(1,blSize(1))).*gamma(1)  (Z2*ones(1,blSize(2))).*gamma(2)  (Z3*ones(1,blSize(3))).*gamma(3)] ...
        + F*ones(1,N).*gamma(4) ...
        + eps;
elseif strcmp(reg_type, 'one') 
    if strcmp(F_type, 'one')
    raw_u =     Z1*ones(1,N).*gamma(1) ...
            + [(F*ones(1,blSize(1))).*gamma(2)   (F*ones(1,blSize(2))).*gamma(3)   (F*ones(1,blSize(3))).*gamma(4)] ...
            + eps;
    elseif strcmp(F_type, 'three')
    raw_u =     Z1*ones(1,N).*gamma(1) ...
            + [(F1*ones(1,blSize(1))).*gamma(2)   (F2*ones(1,blSize(2))).*gamma(3)   (F3*ones(1,blSize(3))).*gamma(4)] ...
            + eps;
       
    end
end
clearvars -except raw_u T

u  = tiedrank(raw_u)./(T+1);