function [Z, Z_hat] = reg_generate(other,ar,model,rng_type,seed)

T = other(1); N = other(2);
reg_type = model(1); F_type = model(2);
kk = 2*strcmp(reg_type, 'three'); jj = 2*strcmp(F_type, 'three');

Z_1 = randn(RandStream.create(rng_type,'NumStreams',N+2+jj+kk,'StreamIndices',1,'Seed',seed),T,1);

if strcmp(reg_type, 'one')
    % AR(1) Regressor
    W = zeros(T,1); W(1) = Z_1(1);
    for tt = 2:T
        W(tt) = ar*W(tt-1)+ Z_1(tt);
    end
    mdl    = arima(1,0,0); mdl_hat = estimate(mdl,W,'Display','off');
    Z_hat_1  = infer(mdl_hat,W);
    Z     = Z_1;
    Z_hat = Z_hat_1;

elseif strcmp(reg_type, 'three')
    % AR(1) Regressor
    W = zeros(T,1); W(1) = Z_1(1);
    for tt = 2:T
        W(tt) = ar*W(tt-1)+ Z_1(tt);
    end
    mdl    = arima(1,0,0); mdl_hat = estimate(mdl,W,'Display','off');
    Z_hat_1  = infer(mdl_hat,W);
    % log-abs GJR GARCH
    phi       = [0.1, 0.65, 0.1, 0.10, 0.5]; 
    Z_02 = randn(RandStream.create(rng_type,'NumStreams',N+4+jj,'StreamIndices',2,'Seed',seed),T,1);
    W = tarch_simulate(Z_02,phi(3:5)',1,0,1,'NORMAL',2); % P=1,O=0,Q=1 leads to GARCH model
    [~,~,ht,~,~,~,~] = tarch(W,1,0,1,'NORMAL',2,phi(3:5)',optimset('display','off'));
    Z_hat_2 = log((abs(W)./sqrt(ht))); Z_2 = log((abs(Z_02)));
    % WN
    Z_3 = randn(RandStream.create(rng_type,'NumStreams',N+4+jj,'StreamIndices',3,'Seed',seed),T,1);
    Z = [Z_1, Z_2, Z_3]; Z_hat = [Z_hat_1 Z_hat_2 Z_3];
end
end